using PkmnLib.Dynamic.ScriptHandling;
using PkmnLib.Static;

namespace PkmnLib.Dynamic.Models.Choices;

/// <summary>
/// A choice to use an item
/// </summary>
public interface IItemChoice : ITurnChoice
{
    
}

/// <inheritdoc cref="IItemChoice"/>
public class ItemChoice : TurnChoice, IItemChoice
{
    public ItemChoice(IPokemon user, IItem item) : base(user)
    {
        Item = item;
    }

    public IItem Item { get; }

    /// <inheritdoc />
    public override int ScriptCount => User.ScriptCount;

    /// <inheritdoc />
    public override void GetOwnScripts(List<IEnumerable<ScriptContainer>> scripts)
    {
    }

    /// <inheritdoc />
    public override void CollectScripts(List<IEnumerable<ScriptContainer>> scripts)
    {
        User.CollectScripts(scripts);
    }
}