using PkmnLib.Dataloader;

namespace PkmnLib.Tests.Dataloader;

public class TypeDataloaderTests
{
    [Test]
    public void TestPrimaryTypesFile()
    {
        using var file = File.Open("Data/Types.csv", FileMode.Open);
        var library = TypeDataLoader.LoadTypeLibrary(file);
        Assert.That(library, Is.Not.Null);
        
        var fire = library.TryGetTypeIdentifier("Fire", out var fireId);
        Assert.That(fire, Is.True);
        var grass = library.TryGetTypeIdentifier("Grass", out var grassId);
        Assert.That(grass, Is.True);
        
        var fireEffectiveness = library.GetSingleEffectiveness(fireId, grassId);
        Assert.That(fireEffectiveness, Is.EqualTo(2.0f));
    }
}